ghc-lib-parser-9.14.1.20251220: The GHC API, decoupled from GHC versions

Safe Haskell | Ignore
Language | GHC2021

GHC.Types.IPE

Synopsis

- type DCMap = UniqDFM DataCon (DataCon, NonEmpty (Int, Maybe IpeSourceLocation))
- type ClosureMap = UniqDFM Name (Name, (Type, Maybe IpeSourceLocation))
- data InfoTableProvMap = InfoTableProvMap {
  - provDC :: DCMap
  - provClosure :: ClosureMap
  - provInfoTables :: InfoTableToSourceLocationMap
  }
- emptyInfoTableProvMap :: InfoTableProvMap
- type IpeSourceLocation = (RealSrcSpan, LexicalFastString)

# Documentation

type DCMap = UniqDFM DataCon (DataCon, NonEmpty (Int, Maybe IpeSourceLocation)) #

A map storing all the different uses of a specific data constructor and the approximate source position that usage arose from. The `Int` is an incrementing identifier which distinguishes each usage of a constructor in a module. It is paired with the source position the constructor was used at, if possible and a string which names the source location. This is the same information as is the payload for the `SourceNote` constructor.

type ClosureMap = UniqDFM Name (Name, (Type, Maybe IpeSourceLocation)) #

A map from a `Name` to the best approximate source position that name arose from.

data InfoTableProvMap #

Constructors

InfoTableProvMap |
Fields provDC :: DCMap provClosure :: ClosureMap provInfoTables :: InfoTableToSourceLocationMap

emptyInfoTableProvMap :: InfoTableProvMap #

type IpeSourceLocation = (RealSrcSpan, LexicalFastString) #

Position and information about an info table. For return frames these are the contents of a `SourceNote`.